WEBINARSandboxes for AI agents, Oct 7th.Claude Code and Cursor get their own Sandbox. See it live Oct 7th.Save my seat

Build Windows Docker Image

View as Markdown
  • POST
  • /workspaces
  • /:workspace
  • /projects
  • /:project_name
  • /pipelines
  • /:pipeline_id
  • /actions

Creates a new Build Windows Docker Image action in the pipeline

Request

REQUIRED SCOPES
PIPELINE_WRITE
URL PARAMETERS
workspacerequiredstring
The human-readable ID of the workspace

Example: "my-company"

project_namerequiredstring
The human-readable ID of the project

Example: "my-project"

pipeline_idrequiredinteger
The ID of the pipeline

Example: 123

BODY PARAMETERS
typerequiredstring
The type of the action

Value: NATIVE_BUILD_WINDOWS_DOCKER

after_action_idinteger
The numerical ID of the action, after which this action should be added
namerequiredstring
The name of the action
trigger_timestring enum
Specifies when the action should be executed
Allowed enum:
ON_EVERY_EXECUTION,
ON_FAILURE,
ON_BACK_TO_SUCCESS,
ON_WARNING,
ON_WAIT_FOR_APPROVE,
ON_TERMINATE
trigger_conditionsTriggerConditionView[]
The list of trigger conditions to meet so that the action can be triggered
run_nextstring enum
Defines whether the action should run in parallel with the next one
Allowed enum:
WAIT_ON_SUCCESS,
IN_SOFT_PARALLEL,
IN_HARD_PARALLEL
run_only_on_first_failureboolean
Defines whether the action should be executed on each failure. Restricted to and required if the trigger_time is ON_FAILURE
variablesEnvironmentVariableView[]
The list of variables you can use the action
disabledboolean
When set to true the action is disabled. By default it is set to false
timeoutinteger
The timeout in seconds
ignore_errorsboolean
If set to true the execution will proceed, mark action as a warning and jump to the next action. Doesn't apply to deployment actions
retry_countinteger
Number of retries if the action fails
retry_intervalinteger
Delay time between auto retries in seconds
loopstring[]
The list of commands that will be executed in a loop
current_revisionstring
The git revision of the last successful run of the action
working_directorystring
The directory in which the pipeline filesystem will be mounted
execute_every_commandboolean
If set to true all commands will be executed regardless of the result of the previous command
commandsstring[]
The commands to execute in the native build environment
deployment_excludesstring[]
The list of files or directories to exclude from deployment
vm_from_prev_actionboolean
If set to true, the VM from the previous action will be used
vm_action_idinteger
The ID of the action from which the VM will be used
vm_action_namestring
The name of the action from which the VM will be used
instance_typestring enum
The type of instance to use for the native build
Allowed enum:
GENERAL_MEDIUM,
GENERAL_LARGE,
GENERAL_XLARGE,
GENERAL_2XLARGE,
COMPUTE_MEDIUM,
COMPUTE_LARGE,
COMPUTE_XLARGE,
COMPUTE_2XLARGE,
ARM_GENERAL_MEDIUM,
ARM_GENERAL_LARGE,
ARM_GENERAL_XLARGE,
ARM_GENERAL_2XLARGE,
ARM_COMPUTE_MEDIUM,
ARM_COMPUTE_LARGE,
ARM_COMPUTE_XLARGE,
ARM_COMPUTE_2XLARGE
distributionstring enum
The AWS distribution type
Allowed enum:
UBUNTU_20_04,
AMI,
WINDOWS_SERVER_2025,
PREVIOUS_ACTION
amiAmiView
Set if distribution is set to AMI.
dockerfile_pathstring
The path to the Dockerfile
context_pathstring
The path to the Docker build context
build_argsstring[]
The list of build arguments to pass to the Docker build
target_stagestring
The target stage of the Dockerfile
pullboolean
If set to false, the image will not be pulled before building
docker_registrystring enum
The type of registry from which the image is retrieved
Allowed enum:
NONE,
DOCKER_HUB,
AMAZON_ECR,
GOOGLE_GCR,
GOOGLE_ARTIFACT_REGISTRY,
OTHER,
GIT_HUB_CONTAINER_REGISTRY,
ARTIFACT_REGISTRY,
DIGITAL_OCEAN_CONTAINER_REGISTRY
repositorystring
The name of the Docker repository. Setting it makes the action push the built image to that repository, which requires an integration (or a login and password) for the target registry. Leave it out to build the image without pushing and push it from a separate DOCKER_PUSH action
artifact_identifierstring
The identifier of the artifact from artifact registry
versionsstring[]
The list of image versions to build or push
docker_image_tagstring
The tag of the Docker image
registrystring
The URL of the Docker registry
insecure_registryboolean
If set to true, the registry will be accessed over HTTP instead of HTTPS
loginstring
The username for the Docker registry
passwordstring
The password for the Docker registry
regionstring
The region for the Docker registry (for AWS ECR)
integrationDockerIntegrationRef
Docker registry integration (DOCKER_HUB|GOOGLE_SERVICE_ACCOUNT|AMAZON|GIT_HUB|GIT_HUB_ENTERPRISE)

Response

RESPONSE BODY
typestring
The type of the action

Value: NATIVE_BUILD_WINDOWS_DOCKER

urlread-onlystring
API endpoint to GET this object
html_urlread-onlystring
Web URL to view this object in Buddy.works
idinteger
The ID of the action
namestring
The name of the action
current_revisionstring
The git revision of the last successful run of the action
trigger_timestring enum
Specifies when the action should be executed
Allowed enum:
ON_EVERY_EXECUTION,
ON_FAILURE,
ON_BACK_TO_SUCCESS,
ON_WARNING,
ON_WAIT_FOR_APPROVE,
ON_TERMINATE
trigger_conditionsTriggerConditionView[]
The list of trigger conditions to meet so that the action can be triggered
run_nextstring enum
Defines whether the action should run in parallel with the next one
Allowed enum:
WAIT_ON_SUCCESS,
IN_SOFT_PARALLEL,
IN_HARD_PARALLEL
run_only_on_first_failureboolean
Defines whether the action should be executed on each failure. Restricted to and required if the trigger_time is ON_FAILURE
variablesEnvironmentVariableView[]
The list of variables you can use the action
disabledboolean
When set to true the action is disabled. By default it is set to false
timeoutinteger
The timeout in seconds
ignore_errorsboolean
If set to true the execution will proceed, mark action as a warning and jump to the next action. Doesn't apply to deployment actions
retry_countinteger
Number of retries if the action fails
retry_intervalinteger
Delay time between auto retries in seconds
last_execution_statusstring enum
The status of the last run of the action
Allowed enum:
INPROGRESS,
ENQUEUED,
TERMINATED,
SUCCESSFUL,
FAILED,
INITIAL,
NOT_EXECUTED,
SKIPPED,
TERMINATING,
WAITING_FOR_APPLY,
WAITING_FOR_VARIABLES,
WAITING_FOR_SETTABLE_VARIABLES,
WAITING_FOR_VT_SESSION
pipelineShortPipelineView
Short representation of a pipeline
permissionsPermissionsView
Access permissions configuration
loopstring[]
The list of commands that will be executed in a loop
working_directorystring
The directory in which the pipeline filesystem will be mounted
execute_every_commandboolean
If set to true all commands will be executed regardless of the result of the previous command
commandsstring[]
The commands to execute in the native build environment
deployment_excludesstring[]
The list of files or directories to exclude from deployment
vm_from_prev_actionboolean
If set to true, the VM from the previous action will be used
vm_action_idinteger
The ID of the action from which the VM will be used
vm_action_namestring
The name of the action from which the VM will be used
instance_typestring enum
The type of instance to use for the native build
Allowed enum:
GENERAL_MEDIUM,
GENERAL_LARGE,
GENERAL_XLARGE,
GENERAL_2XLARGE,
COMPUTE_MEDIUM,
COMPUTE_LARGE,
COMPUTE_XLARGE,
COMPUTE_2XLARGE,
ARM_GENERAL_MEDIUM,
ARM_GENERAL_LARGE,
ARM_GENERAL_XLARGE,
ARM_GENERAL_2XLARGE,
ARM_COMPUTE_MEDIUM,
ARM_COMPUTE_LARGE,
ARM_COMPUTE_XLARGE,
ARM_COMPUTE_2XLARGE
distributionstring enum
The AWS distribution type
Allowed enum:
UBUNTU_20_04,
AMI,
WINDOWS_SERVER_2025,
PREVIOUS_ACTION
amiAmiView
Set if distribution is set to AMI.
dockerfile_pathstring
The path to the Dockerfile
context_pathstring
The path to the Docker build context
build_argsstring[]
The list of build arguments to pass to the Docker build
target_stagestring
The target stage of the Dockerfile
pullboolean
If set to false, the image will not be pulled before building
docker_registrystring enum
The type of registry from which the image is retrieved
Allowed enum:
NONE,
DOCKER_HUB,
AMAZON_ECR,
GOOGLE_GCR,
GOOGLE_ARTIFACT_REGISTRY,
OTHER,
GIT_HUB_CONTAINER_REGISTRY,
ARTIFACT_REGISTRY,
DIGITAL_OCEAN_CONTAINER_REGISTRY
repositorystring
The name of the Docker repository. Setting it makes the action push the built image to that repository, which requires an integration (or a login and password) for the target registry. Leave it out to build the image without pushing and push it from a separate DOCKER_PUSH action
artifact_identifierstring
The identifier of the artifact from artifact registry
versionsstring[]
The list of image versions to build or push
docker_image_tagstring
The tag of the Docker image
registrystring
The URL of the Docker registry
insecure_registryboolean
If set to true, the registry will be accessed over HTTP instead of HTTPS
loginstring
The username for the Docker registry
passwordstring
The password for the Docker registry
regionstring
The region for the Docker registry (for AWS ECR)
integrationIntegrationIdentifierView
The integration used by the action

Last modified on Oct 6, 2026

Request example

curl -X POST "https://api.buddy.works/workspaces/:workspace/projects/:project_name/pipelines/:pipeline_id/actions" \ -H "Authorization: Bearer <YOUR-TOKEN>" \ -H "Content-Type: application/json" \ -d '{ "name": "Build Windows Docker image", "type": "NATIVE_BUILD_WINDOWS_DOCKER", "trigger_time": "ON_EVERY_EXECUTION", "distribution": "WINDOWS_SERVER_2025", "dockerfile_path": "Dockerfile", "context_path": ".", "docker_registry": "ARTIFACT_REGISTRY", "artifact_identifier": "my-windows-image", "versions": [ "latest", "$BUDDY_RUN_COMMIT" ], "build_args": [ "APP_VERSION=$BUDDY_RUN_COMMIT" ], "target_stage": "production", "pull": true }'
STATUS
200 OK